// A completely random thing that I made up to draw 
// lacy line structures based on randomly generated
// polyomials.  You definitely don't need to understand
// the math in this sketch.  Really, I don't understand
// it myself -- this is the sort of thing I tried 
// without planning how, or whether, it would work.

float[] poly1;
float[] poly2;
int degree;

void makePoly()
{
  degree = int( random( 10 ) );
  int sz = (1+degree)*(1+degree);
  
  poly1 = new float[sz];
  poly2 = new float[sz];
  for( int idx = 0; idx < sz; ++idx ) {
    poly1[idx] = random( -2, 2 );
    poly2[idx] = random( -2, 2 );
  }
}

float evalPoly( float[] p, float a, float b )
{
  float[] as = new float[ 1 + degree ];
  float[] bs = new float[ 1 + degree ];

  as[0] = 1;
  bs[0] = 1;
  
  for( int idx = 1; idx < 1 + degree; ++idx ) {
    as[idx] = as[idx-1]*a;
    bs[idx] = bs[idx-1]*b;
  }

  float total = 0.0;
  for( int r = 0; r <= degree; ++r ) {
    for( int c = 0; c <= degree; ++c ) {
      total += as[r]*bs[c]*p[r*(degree+1)+c];
    }
  }
  
  return total;
}

void setup()
{
  size( 500, 500 );
  background( 0 );
  stroke( 255, 10 );
  strokeWeight( 0.25 );
  makePoly();
}

void draw()
{
  for ( int idx = 0; idx < 100; ++idx ) {
    float x = random( width );
    float y = random( height );

    float a = map( x, 0, width, -1, 1 );
    float b = map( y, 0, height, -1, 1 );
   
    b = b - 0.4; 

    float na = evalPoly( poly1, a, b );
    float nb = evalPoly( poly2, a, b );
    
    float sl = atan2( nb-b, na-a )/TWO_PI + 0.5;
    colorMode( HSB, 100 );
    stroke( lerp(60,80,sl), 100, 100, 10 );

    line( x, y, map( na, -1, 1, 0, width ),
      map( nb, -1, 1, 0, height ) );
  }
}

void keyPressed()
{
  makePoly();
  background( 0 );
}